// ignore_for_file: non_constant_identifier_names

class PamMessageModel {
  final String URL;
  final String Pixel;
  final String Flex;
  String? PageTitle;
  String? Id;

  PamMessageModel({
    required this.URL,
    required this.Pixel,
    required this.Flex,
    this.PageTitle,
    this.Id,
  });

  factory PamMessageModel.fromJson(
      String appPrefix, Map<String, dynamic>? rawJson) {
    Uri uri = Uri.parse(rawJson?["url"]);
    String id = uri.queryParameters["id"] ?? "";
    String? pageTitle;

    if (uri.path.startsWith("$appPrefix//products")) {
      pageTitle = id == "" ? "products" : "product_detail";
    }

    return PamMessageModel(
      URL: rawJson?["url"] ?? "",
      Pixel: rawJson?["pixel"] ?? "",
      Flex: rawJson?["flex"] ?? "",
      Id: id,
      PageTitle: pageTitle,
    );
  }

  Map<String, dynamic> toMap() {
    return Map<String, dynamic>.from({
      "url": this.URL,
      "pixel": this.Pixel,
      "flex": this.Flex,
      "id": this.Id ?? "",
      "page_title": this.PageTitle ?? "",
    });
  }
}
